<?php

namespace Teknisa\SM\Util\Procedure;

use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class FctGeraContrato {
    
    const NOME = "FCT_GERA_CONTRATO";
    private $connection;
    
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }
    
    /**
     * Executa a procedure.
     * 
     * @param integer $nrorg
     * @param string  $idorcacontr
     * @param integer $nrseq
     * 
     * @return integer
     */
    public function executar($nrorg, $nrseqorcamento, $cdoperador) {
        $procedure = new StoredProcedure($this->connection, self::NOME);
        
        $procedure->addParam(new Param("P_NRORG",           Param::PARAM_INPUT,  $nrorg,            Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRSEQORCAMENTO",  Param::PARAM_INPUT,  $nrseqorcamento,   Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param("P_NRSEQCONTRATO",   Param::PARAM_OUTPUT, null,              Param::PARAM_TYPE_INT, 12));
        $procedure->addParam(new Param("P_CDOPERADOR",      Param::PARAM_INPUT,  $cdoperador,       Param::PARAM_TYPE_STR, 12));
        
        $resultado = $procedure->execute();
        return $resultado["P_NRSEQCONTRATO"];
    }
    
}

?>