var engine = function (eventAggregator, General, ScreenService, LibUtilities, localStorageEngine, ZHPromise, LibLoginController, ZhuAclController, templateManager, ApplicationContext) {
    
	/*---------------LOGIN---------------*/
    var validateLoginResponse = function(response, loginDefer) {
        var responseold = response;
        response = LibUtilities.changeLoginResponseToOldParams(response);
        if(response && response.cdoperador) {
            
            eventAggregator.publish("loginSuccess", responseold);
            eventAggregator.publish("authSuccess", { user: response });
            loginDefer.resolve();
            
            /*if (!window.location.hash || window.location.hash.endsWith("product#dashboard") || !localStorageEngine.getLocalVar("CDOPERADOR") || localStorageEngine.getLocalVar("CDOPERADOR") != response.cdoperador) {
                
                eventAggregator.publish("authSuccess", { user: response });
            }
            else {
                setParameters(response);
            }*/
        }
    };
    
    this.authenticateUser = function() {
        if(typeof memoryStorage !== 'undefined') {
            localStorageEngine.getLocalVar = memoryStorage.getLocalVar;
            localStorageEngine.setLocalVar = memoryStorage.setLocalVar;
            setLocalVar = memoryStorage.setLocalVar;
            getLocalVar = memoryStorage.getLocalVar;
        }
        
        var loginDefer = ZHPromise.defer();
        localStorageEngine.setLocalVar('loginPromise', loginDefer.promise);

        LibLoginController.authenticate().then(function(response) {
            validateLoginResponse(response, loginDefer);
        }).catch(function (error) {
				if (error.data) {
					ScreenService.showMessage(error.data.error);
				} else {
					ScreenService.showMessage(JSON.stringify(error));
				}
			});
    };
    
    this.confirmLogoutLib = function(){
        ScreenService.confirmMessage("Deseja realmente sair do sistema?", "question", function(){
            LibLoginController.logout();
        }, null);
    };
	
	eventAggregator.subscribe("beforeProjectStartup", function() {
		this.authenticateUser();
	}.bind(this));
	
    var setParameters = function(user) {
        var dataAtual = moment().format("DD/MM/YYYY");
        ScreenService.buildUserData(user.nmoperador, [dataAtual, user.nmorg]);
    };
    
    var setLocalVars = function(user) {
        localStorageEngine.setLocalVar('SM_CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('SM_CDFILIAL', user.cdfilialselecionada);
        localStorageEngine.setLocalVar('SM_NMFILIAL', user.nmfilialselecionada);
        localStorageEngine.setLocalVar('SM_NRORG', user.nrorg);
        localStorageEngine.setLocalVar('SM_NMORG', user.nmorg);
        localStorageEngine.setLocalVar('SM_NRORGTRAB', user.nrorgtrab);
        localStorageEngine.setLocalVar('CDOPERADOR', user.cdoperador);
        localStorageEngine.setLocalVar('NMOPERADOR', user.nmoperador);
        localStorageEngine.setLocalVar('CDFILIAL', user.cdfilialselecionada);
        localStorageEngine.setLocalVar('NMFILIAL', user.nmfilialselecionada);
        localStorageEngine.setLocalVar('NRORG', user.nrorg);
        localStorageEngine.setLocalVar('NRORGTRAB', user.nrorgtrab);
    };

    eventAggregator.subscribe('authSuccess', function(session) {
        var user = session.user;
        
        setLocalVars(user);
        setUserID(user);
        setParameters(user);
        setGeneralParameters(user.nrorg);
        /*var parameters = resolvePromiseWhenAnyResult(setParameters(user));

        ZHPromise.all([parameters]).then(function() {
            ScreenService.openWindow('product#dashboard');
        });*/
        var cdoperador     = user.cdoperador;
        var perfilDeAcesso = user.perfilDeAcesso;
        /* Zeedhi Access Control */
        localStorageEngine.setLocalVar("userId", cdoperador);
        localStorageEngine.setLocalVar("accessProfiles", perfilDeAcesso);
        localStorageEngine.setLocalVar("productIdLoginUrl", 911);
    }.bind(this));
    
    /* --------- CONFIGURAÇÕES DF --------- */
    function replaceMask(value, regex) {
        return typeof (value) === 'string' ? value.replace(regex, '*') : value;
    }
    
    var regularExpressions = {
        LETTERS: /((a|A))/g,
        LETTERS_AND_NUMBERS: /((a|A|9))/g
    };
    
    function setGeneralParameters(nrorg) {
        return getParamgeral().then(function (paramgeral) {
            if (paramgeral) {
                localStorageEngine.setLocalVar('CAD_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTPROD', replaceMask(paramgeral.CDPICTPROD, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('CDPICTCCTB', replaceMask(paramgeral.CDPICTCCTB, regularExpressions.LETTERS));
                localStorageEngine.setLocalVar('GER_CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
                localStorageEngine.setLocalVar('CDPICTPRAT', replaceMask(paramgeral.CDPICTPRAT, regularExpressions.LETTERS_AND_NUMBERS));
            } else {
                ScreenService.showMessage("Parâmetros gerais não configurados", "E");
            }
        });
    }
    
    function getParamgeral() {
        return getTableByName("paramgeral").then(function(response) {
            var paramgeral = null;
            if (response.length)
                paramgeral = response[0];
            return paramgeral;
        });
    }
    
    function getTableByName(tableName, filter) {
        if (!filter) {
            filter = [];
        }
        return General.callRestEngine("product#/crud/" + tableName, "FilterData", filter).then(function (response) {
            var result = [];
            if (response.dataset[tableName])
                result = response.dataset[tableName];
            return result;
        });
    }

    var setUserID = function(user) {
        //ZhPreferences.setUserID(user.cdoperador);
        if(ApplicationContext.ZhPreferences) {
            ApplicationContext.ZhPreferences.setUserID(user.cdoperador);
        } else {
            ApplicationContext.zhCustomizationsService.registerUser(user.cdoperador);
        }
    };

    /*function resolvePromiseWhenAnyResult(promise) {
        if (promise) {
            return promise.then(function (result) {
                return result;
            })
            .catch(function (error) {
                return error;
            });
        }
    }*/
    
    eventAggregator.subscribe("onContainerOpen", function (openEvent) {
        var container = openEvent.container;
        if(container && container.label) {
            var updatedTitle = ScreenService.i18n(container.label) + " - SM";
            templateManager.updateTitle(updatedTitle);
        }
    });
};

Configuration(function(ContextRegister) {
    ContextRegister.register("engine", engine);
});